local initialized = false
local butts = {}

function init()
   local x = math.ceil((app.gui.width-280)/2)
   
   app.buttons.AddClasses   = app.gui.newButton(x,040, 280,40, {root = true}):setText(app.strings['Add a class'], 'center', 'center'):show()
   app.buttons.SaveData = app.gui.newButton(x-50,040, 40,40, {root = true}):setText('[S]', 'center', 'center'):show()
   app.buttons.BackToMainClasses = app.gui.newButton(x,app.gui.height-80,280,40,  {root = true}):setText(app.strings['Back'], 'center', 'center'):show()
   
   local lab  = app.gui.newLabel(x,120,280,40,{root=true, fontColor={255,255,255}}):setText(app.strings['List of Classes'],"center","center"):show()
   local grid = app.gui.newGrid(x,160,240,40,{root=true}):show()
   grid.hightlightOnHover  =  true
   
   local pan = app.gui.newPanel(math.ceil((app.gui.width-340)/2),310,340, 180, {root=true, darkenBG = true}):show()
   
   app.gui.newLabel(0,20,340,40):setParent(pan):setText(app.strings['Name new class'],"center","center"):show()
   local edit = app.gui.newEdit(20,60,300,40):setParent(pan):show()
   app.buttons.ConfirmAddClasses = app.gui.newButton(20, 120,130,40):setParent(pan):setText(app.strings['Ok'], 'center', 'center'):show()
   app.buttons.CancelAddClasses  = app.gui.newButton(190,120,130,40):setParent(pan):setText(app.strings['Cancel'], 'center', 'center'):show()
   

   for i = 1, #app.classes do
       grid:setCellData(1, i, app.classes[i].name, {280, 40}, nil,   nil,          nil,       bghd)
   end
  
   function app.buttons.SaveData:onClick()
      love.filesystem.write('data.lua','return '.. app.dump(app.data))
   end

   function app.buttons.ConfirmAddClasses:onClick()
      app.classes[#app.classes+1] = {name= edit.text, students = {}, holidays={}, workingdays = {}}      
                    -- x, y, text,              size,     icons, outlineColor, textColor, bgColor 
      grid:setCellData(1, #app.classes, edit.text, {280, 40}, nil,   nil,          nil,       bghd)
      butts[#butts+1] = butt
      app.buttons.AddClasses:show()
      app.buttons.BackToMainClasses:show()
      grid:show()      
      lab:show()
      edit:setText('')
      pan:hide()
   end
   
   function app.buttons.CancelAddClasses:onClick()
      app.buttons.AddClasses:show()
      app.buttons.BackToMainClasses:show()
      grid:show()      
      lab:show()
      edit:setText('')
      pan:hide()
   end
   app.buttons.CancelAddClasses:onClick()

   function app.buttons.AddClasses:onClick()
      pan:show()
      edit:setFocus()
      lab:hide()
      app.buttons.AddClasses:hide()
      app.buttons.BackToMainClasses:hide()
      grid:hide()
   end

   function app.buttons.BackToMainClasses:onClick()
      app:rebuildGui('main') 
   end
   
   function grid:onClick(x,y)
      local x,y = grid:getCellAt(x,y)
      local data = grid:getCellData(x,y)
      local class = data.text
      app.selected_class = class
      app:rebuildGui('students')      
   end
end

function love.keyreleased(key)
   if key == "escape" then
      app:rebuildGui('main') 
   end
end

function love.update(dt)
   if not initialized then
      init()
      initialized = true
      return 
   end
   app.gui:update(dt)
end

function love.draw()
   app.gui:draw()
end