local initialized = false
local butts = {}

function init()
   local x = math.ceil((app.gui.width-280)/2)
   
   app.buttons.AddStudents   = app.gui.newButton(x,040, 280,40, {root = true}):setText(app.strings['Add a student'], 'center', 'center'):show()
   app.buttons.SetWorkingDaysClasses = app.gui.newButton(x+300,040, 40,40, {root = true}):setText('[Ξ]', 'center', 'center'):show()
   app.buttons.SaveData = app.gui.newButton(x-50,040, 40,40, {root = true}):setText('[S]', 'center', 'center'):show()
   app.buttons.BackToMainStudents = app.gui.newButton(x,app.gui.height-80,280,40,  {root = true}):setText(app.strings['Back'], 'center', 'center'):show()
   local scroll = app.gui.newScrollBox(0,160,app.gui.width, app.gui.height-80-180,{root=true}):show()
   print(app.dump(app.selected_class))
   local lab  = app.gui.newLabel(x,120,280,40,{root=true, fontColor={255,255,255}}):setText(app.strings['List of Students of'].." "..(app.selected_class or ""),"center","center"):show()
   local grid = app.gui.newGrid(20,0,240,40):setParent(scroll):show()
   grid.hightlightOnHover  =  true

   local pan = app.gui.newPanel(math.ceil((app.gui.width-340)/2),310,340, 180, {root=true, darkenBG = true}):hide()
   app.gui.newLabel(0,20,340,40):setParent(pan):setText(app.strings['Enter student\'s name'],"center","center"):show()
   local edit = app.gui.newEdit(20,60,300,40):setParent(pan):show()
   app.buttons.ConfirmAddStudents = app.gui.newButton(20, 120,130,40):setParent(pan):setText(app.strings['Ok'], 'center', 'center'):show()
   app.buttons.CancelAddStudents  = app.gui.newButton(190,120,130,40):setParent(pan):setText(app.strings['Cancel'], 'center', 'center'):show()
   
   function app.buttons.SaveData:onClick()
      love.filesystem.write('data.lua','return '.. app.dump(app.data))
   end

   local class
   for c=1, #app.classes do
       if app.selected_class == app.classes[c].name then
          class = app.classes[c]
          break 
       end
   end
       
   function app.buttons.SetWorkingDaysClasses:onClick()
      app:rebuildGui("workingdays")
   end

   local datepicker = app.gui.newDatePicker(math.ceil((app.gui.width-340)/2),20,340, 20):setParent(app.gui.root):show()
   datepicker.panl:hide()
   
   local gheight = 0
   for i = 1, #app.students do
       local student = app.students[i]              
       print(i,student)
       if student.class == app.selected_class then
          gheight = gheight + 1
          grid:setCellData(1, gheight, student.name, {160, 40}, nil,  nil,    nil,       bghd, student, true)
          grid:setCellData(2, gheight, "н", {40, 40}, nil,   nil,          nil,       bghd, student)
          grid:setCellData(3, gheight, "+", {40, 40}, nil,   nil,          nil,       bghd, student)
          grid:setCellData(4, gheight, "-", {40, 40}, nil,   nil,          nil,       bghd, student)      
          grid:setCellData(5, gheight, "2", {40, 40}, nil,   nil,          nil,       bghd, student)
          grid:setCellData(6, gheight, "3", {40, 40}, nil,   nil,          nil,       bghd, student)
          grid:setCellData(7, gheight, "4", {40, 40}, nil,   nil,          nil,       bghd, student)
          grid:setCellData(8, gheight, "5", {40, 40}, nil,   nil,          nil,       bghd, student)
       end
   end

   function app.buttons.ConfirmAddStudents:onClick()
      local student = {name= edit.text, marks = {}, absense={}, behaviour = {}, class = app.selected_class}
      student.id = #app.students+1
      app.students[student.id] = student
      --class.students[#class.students+1] = student -- don't do it, or load will be convoluted
                    -- x, y, text,              size,     icons, outlineColor, textColor, bgColor 
                     --x,             y,      text, size,    icons, outlineColor, textColor, bgColor, object, dbg
                     print(student)
      grid:setCellData(1, #app.students, edit.text, {160, 40}, nil,  nil,    nil,       bghd, student)
      grid:setCellData(2, #app.students, "н", {40, 40}, nil,   nil,          nil,       bghd, student)
      grid:setCellData(3, #app.students, "+", {40, 40}, nil,   nil,          nil,       bghd, student)
      grid:setCellData(4, #app.students, "-", {40, 40}, nil,   nil,          nil,       bghd, student)      
      grid:setCellData(5, #app.students, "2", {40, 40}, nil,   nil,          nil,       bghd, student)
      grid:setCellData(6, #app.students, "3", {40, 40}, nil,   nil,          nil,       bghd, student)
      grid:setCellData(7, #app.students, "4", {40, 40}, nil,   nil,          nil,       bghd, student)
      grid:setCellData(8, #app.students, "5", {40, 40}, nil,   nil,          nil,       bghd, student)
      app.buttons.AddStudents:show()
      app.buttons.BackToMainStudents:show()
      grid:show()      
      lab:show()
      edit:setText('')
      pan:hide()
   end
   
   function app.buttons.CancelAddStudents:onClick()
      app.buttons.AddStudents:show()
      app.buttons.BackToMainStudents:show()
      grid:show()      
      lab:show()
      edit:setText('')
      pan:hide()
   end

   function app.buttons.AddStudents:onClick()
      pan:show()
      edit:setFocus()
      lab:hide()
      app.buttons.AddStudents:hide()
      app.buttons.BackToMainStudents:hide()
      grid:hide()
   end

   function app.buttons.BackToMainStudents:onClick()
      app:rebuildGui('classes') 
   end
   
   function grid:onClick(x,y)
      local x,y = grid:getCellAt(x,y)      
      local data = grid:getCellData(x,y)      
      if true then return end
      -- need to extract dd.mm.yy w/o the time
      local date = datepicker:getDate()
      
      if   x == 2 then -- absent
           --app.students[data.id]
           data.object.absense[date] = not not not data.object.absense[date]
      elseif x == 3 then -- +           
             data.object.behaviour[date] = ( data.object.behaviour[date] or 0 ) + 1
      elseif x == 4 then -- -           
             data.object.behaviour[date] = ( data.object.behaviour[date] or 0 ) - 1
      elseif x == 5 then -- 2
             data.object.marks[date] = 2
      elseif x == 6 then -- 3
             data.object.marks[date] = 3
      elseif x == 7 then -- 4
             data.object.marks[date] = 4
      elseif x == 8 then -- 5
             data.object.marks[date] = 5
      end

      --print(app.dump(app.data))
      
      
      --local class = data.caption
      --app.selected_class = class
      --app:rebuildGui('students')      
   end
end

function love.keyreleased(key)
   if key == "escape" then
      app:rebuildGui('classes') 
   end
end

function love.update(dt)
   if not initialized then
      init()
      initialized = true
      return 
   end
   app.gui:update(dt)
end

function love.draw()
   app.gui:draw()
end