local initialized = false
local butts = {}
local checks = {}
local dods = {}
local auds = {}
local days = {'Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'}

function init()
   local x = math.ceil((app.gui.width-360)/2)   
   
   app.buttons.SaveData = app.gui.newButton(x-50,040, 40,40, {root = true}):setText('[S]', 'center', 'center'):show()
   app.buttons.BackToStudentsWorkingdays = app.gui.newButton(x+40,app.gui.height-80,280,40,  {root = true}):setText(app.strings['Back'], 'center', 'center'):show()
   
   function app.buttons.SaveData:onClick()
      love.filesystem.write('data.lua','return '.. app.dump(app.data))
   end

   local class
   for c=1, #app.classes do
       if app.selected_class == app.classes[c].name then
          class = app.classes[c]
          break 
       end
   end
   
   for i = 8, 2, -1 do
       local day = i
       if i == 8 then day = 1 end
       local butt = app.gui.newButton(x,160+(i-2)*50,200,40, {root=true}):setText(""):show()
       local check = app.gui.newCheckBox(x,160+(i-2)*50, 200,40, {root=true}):setText(app.strings[days[day]]):show()
       local dod   = app.gui.newComboBox(x+200,160+(i-2)*50,80,40):setParent(app.gui.root):show():setText('0','center','center'):setItems({0,1,2,3,4,5,6,7,8,9,10,11,12,13,14})
       local aud   = app.gui.newComboBox(x+280,160+(i-2)*50,80,40):setParent(app.gui.root):show():setText('0','center','center'):setItems({0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20})
       local oldcc = check.onClick       
       
       dod.bgColor = {220,220,220, 255}
       aud.bgColor = {220,220,220, 255}
       aud.day = day
       dod.day = day
       
       if class.workingdays[day] then
          if class.workingdays[day].order then
             --print(dod,class.workingdays[day].order, #dod.items)
             dod:setIndex(class.workingdays[day].order+1)
             check.checked = true
          end
          if class.workingdays[day].aud then
             aud:setIndex(class.workingdays[day].aud+1)
             check.checked = true
          end      
      end
       
       function check:onClick()
           oldcc(check)
           for j = 1, #checks do               
               local day = j+1
               if day == 8 then day = 1 end
               class.workingdays[day] = {}
               if checks[j].checked then
                  class.workingdays[day] = {order = tonumber(dod:getText() or 0) or 0, aud = tonumber(aud:getText() or 0) or 0}
               end
           end
       end      
       
       
       function butt:onClick()
          check:onClick()
       end
       
       function dod:onSelect(item)     
          --print(self)
          --print(self.day)
          --print(class.workingdays[self.day])
          --print(class.workingdays[self.day].order)
          class.workingdays[self.day].order = tonumber(item)
       end
       
       function aud:onSelect(item)
          class.workingdays[self.day].aud = tonumber(item)
       end
       
       butts[i-1]  = butt
       checks[i-1] = check
       dods[i-1] = dod
   end
       
   local lab  = app.gui.newLabel(x,120,280,40,{root=true, fontColor={255,255,255}}):setText(app.strings['Working Days'].." "..app.selected_class,"center","center"):show()
   


   function app.buttons.BackToStudentsWorkingdays:onClick()
      app:rebuildGui('students') 
   end
   
end

function love.keyreleased(key)
   if key == "escape" then
      app:rebuildGui('students') 
   end
end

function love.update(dt)
   if not initialized then
      init()
      initialized = true
      return 
   end
   app.gui:update(dt)
end

function love.draw()
   app.gui:draw()
end